#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

require 'tmpdir'
require 'pathname'


class VmBench
	
	include Xenodot

	@@stop = false	
	
	def initialize(mult = 4)
		#Xenodot::Backend.sql('set client_min_messages to error;', [], [])
		PiVM.init
		PiVM.load("./benchmark/pi_bench.xml")
		# puts PiVM.agents.to_xml
		PiVM.agents.child.each do |pi|
			mult.times do
				p = PiVM.create_process(pi.child)
				PiVM::Queue.enqueue(p)
			end
		end
	end
	
	def start(seconds, processes, profile = false, second = false)
		@profile = profile
		@starttime = Time.now.tv_sec + 2
		puts "Start benchmarks with #{processes} processes in 2 seconds. Duration #{seconds}s."
		@endtime = @starttime + seconds
		reader = []
		processes.times do
			rd, wr = IO.pipe
			reader << rd
			fork do
				rd.close
				worker(wr)
			end
			wr.close
		end
		count = 0
		processes.times do |i|
			count = count + reader[i].read.to_i
			reader[i].close
			#Process.wait
			#count = count + $?.exitstatus
			#puts $?.inspect
		end
		
		puts "Benchmark finished"
		puts "Result: #{count} steps in #{seconds} s. #{count.to_f / seconds}/s"
		
# 		unless second
# 			Backend::Database.connection
# 			Backend.sql("delete from pivm.vm_queue",[],[])
# 			PiVM.processes.child.each do |p|
# 				p.delete!
# 			end
# 			PiVM.agents.child.each do |pi|
# 				4.times do
# 					p = PiVM.create_process(pi.child)
# 					Queue.enqueue(p)
# 				end
# 			end
# 			p PiVM.processes.to_s
# 			Backend.sql("vacuum full analyze",[],[])
# 			start(seconds,processes, profile, true)
# 		end
	end
	
	def worker(writer)
		#each subprocess need it's own connection
		Backend::Database.remove_connection
		Backend::Database.connection
		#Xenodot::Backend.sql('set client_min_messages to info;', [], [])
		
		Xenodot::Backend.sql("select pivm.profile_start()",[],[]) if @profile
		Xenodot::Backend.sql('select pivm.vm_init();', [], [])
		process_id = nil
		count = 0
		until Time.now.tv_sec >= @starttime do
			sleep 1
		end
		#puts "started #{$$} #{@starttome} #{@endtime}"
		until Time.now.tv_sec >= @endtime do
			#puts "step #{$$}"
			process ||= PiVM::Queue.dequeue
			if process
				process = PiVM.handle_process(process)
			# 			res = Xenodot::Backend.sql('select * from pivm.vm_next_step($1, $2, $3)', [process_id, 0, 'notexisting'],[:int4, :int4, :text], :output => :hashed, :count => 1)
			# 			process_id = res['process_id']
				count += 1
			end
		end
		PiVM::Queue.enqueue(process) if process
		if @profile
			filename = (Pathname.new(Dir.tmpdir) + "profile-#{$$}.txt").to_s
			Backend.sql("select pivm.profile_stop($1)",[filename],[:text])
			puts "Profile is here: #{filename}"
		end
		writer.puts count
		writer.close
	end

end
