#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

require 'active_record'
require 'xenodot_build'

ActiveRecord::Migration.verbose = $PIVM_DEBUG

module Kernel
  def reset_pivm_database
    begin
      ActiveRecord::Base.remove_connection
      Xenodot::Backend::Database.remove_connection
    rescue
    end
 	clean_pivm_database
    connect_xenodot_database
    migrate_pivm_database
  end
  
  def clean_pivm_database
  	clean_xenodot_database
    
    Xenodot::Backend.sql('set client_min_messages to error;', [], []) unless $PIVM_DEBUG
    
    Xenodot::Backend.sql("drop schema pivm cascade;", [], []) rescue {}
  end
  
  def migrate_pivm_database(version = nil)
  	migrate_xenodot_database(version)
    Xenodot::Backend.sql('set client_min_messages to error;', [], []) unless $PIVM_DEBUG
    # the pljava.sql create the schema itself
    Xenodot::Backend.sql("create schema pivm;", [], []) rescue {}
    ActiveRecord::Migrator.migrate(File.join(File.dirname(__FILE__),"migration"), nil)
  end
  
end