#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
 module Activity
 
 	# return the next activity or activities, that follows this activity
 	# in the process
 	def next
 		raise "Abstract method, has to be implemented"
 	end
 	
 	# return the pi type of the activity. The type has to be one of
 	# call, fresh, inaction, match, par, read, replication, sum, tau or write
 	def type
 		raise "Abstract method, has to be implemented"
 	end
 	
 	# return the complement communication operation of this activity. Is the
 	# type of the activity is read, than write will be returned and vice versa.
 	# If the type is neither read nor write the behavior is not specified.
 	def complement
 		(type == 'read') ? 'write' : 'read'
 	end

 end
end
