#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
 class Functions
 
 	def self.lookup_banks(process)
 		bank = URI.parse("http://uri.of.the.bank")
 		process.substitute!('bank',bank)
 	end
 	
 	def self.getbank
 		bank = Xenodot::Backend.sql("select name from pivm.bank_register order by id desc",[],[], :count => 1)
 		return URI.parse(bank[0])
 	end
 	
 	def self.response(uri)
  		response = Templates.bank_response_html(%Q{
  		<h1>The Bank</h1><p><a href="#{uri.to_s}">#{uri.to_s}</a></p>})
 		return 200, response
 	end

 	
 	def self.register(uri)
 		Xenodot::Backend.sql("insert into pivm.bank_register (name) values ($1)",[uri.to_s],[:text])
  		response = Templates.bank_response_html(%Q{<h1>Bank registered successfully!</h1><p><a href="#{uri.to_s}">#{uri.to_s}</a></p>})
 		return 200, response
 	end
 	
 	def self.deregister(uri)
 		res = Xenodot::Backend.sql("delete from pivm.bank_register where name = $1",[uri.to_s],[:text])
 		code, response = [200, Templates.bank_response_html(%Q{<h1>Bank deregistered successfully!</h1><p><a href="#{uri.to_s}">#{uri.to_s}</a></p>})]
 		return code, response
 	end
 	
 end
 
 class Templates
 	def self.bank_response_html(body)
 		%Q{
 			<html><head><title>Bank Broker</title></head>
			<body>
			#{body}
			<form action="/vm/broker" method="post">
				<p>URI der Bank:<br><input name="bank" type="text" size="60"></p>
				<p>
					<input type="radio" name="method" value="register">register<br>
					<input type="radio" name="method" value="deregister">deregister<br>
				</p>
				<p>
					<input type="submit" value="Submit">
					<input type="reset" value="Reset">
				</p>
			</form>
			</body>
			</html>
 		}
 	end
 end
end