#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
	
	include Xenodot


	def self.init
		@root = Node['http://xenodot.org/vm']
		@processes = @root.ensure_child(:vm, :processes)
		@agents = @root.ensure_child(:vm, :agents)
		@intern_agents = @root.ensure_child(:vm, :intern_agents)
		@resp = @intern_agents.ensure_child(:vm, :resp)
		unless @resp.child('read').exist?
			@resp.append_xml('<read channel="backchannel" names="resp"><inaction /></read>')
		end
		@sandbox = @root.ensure_child(:vm, :sandbox)
		@name = QName['names']
	end
	
	%w{agents processes root sandbox name}.each do |n|
		eval  %Q{
			def self.#{n}
				PiVM.init unless @#{n}
				@#{n}
			end
		}
	end
	
	module Agent
		def start
			act = self.child
			act.extend Activity
			act
		end
	end
	
	def self.agent(name)
		agent = agents.child.detect{|n| n[:name] == name.to_s}
		agent.act_as PiVM::Agent
		agent
	end
	
	# Generate unique names 
	def self.fresh_name(prefix = "p")
		if prefix.kind_of? Array
			p prefix
		end
		suffix = Backend.sql("select nextval('pivm.vm_id')",[],[],:count => 1)[0]
		"" << prefix << "_" << suffix.to_s
	end
	
	def self.convert_hash(hash)
		get = PiVM.fresh_name('get')
		hash_name = PiVM.fresh_name('Hash')
		hash_node = @intern_agents.create_child('agent')
		hash_node[:name] = hash_name
		replication = hash_node.create_child('replication')
		read = replication.create_child(:read)
		read[:channel] = get
		read[:names] = [:key, :ret]
		sum = read.create_child(:sum)
		#p hash_node.to_s
		hash.each{ |key, value|
			match = sum.create_child(:match)
			#p match
			match[:x] = 'key'
			match[:y] = key
			write = match.create_child(:write)
			write[:channel] = 'ret'
			write[:names] = value
			write.create_child(:inaction)
		}
		p = PiVM.create_process(replication)
		PiVM::Queue.enqueue(p,'read',get,-1,true)
		get
	end

end
