#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
 module Process
 
 	def self.new
 		process = PiVM.processes.create_child(:process)
		process.ensure_child(:names)
		process.act_as PiVM::Process
 	end
 	
 	def clone
 		p = PiVM.processes.append_clone self
 		p.act_as PiVM::Process
 	end

	def substitute(name)
		@map = self.fast_child('names') unless @map
		if name.kind_of? Array
			name.collect do |n|
				@map[n] || n
			end
		else
			p "substitute #{name}" if $DEBUG
			@map[name] || name
		end
	end
	
 	def substitute!(name, value)
		@map = self.fast_child('names') unless @map
		if name.kind_of? Array
			name.each_with_index do |n,i|
				@map[n] = value[i]
			end
		else      
			@map[name] = value
		end
 	end
 	
 	def attr(*args)
 		self[args] 
 	end
	
	def current_activity
		@current_activity ||= self[:pi]
		@current_activity.act_as Activity unless @current_activity.kind_of? Activity
		@current_activity
	end
 
 	def current_activity=(activity)
 		@current_activity = self[:pi] = activity
	end

 end
end
