#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
 class Queue
 
 
 
	# enque a process into the waiting queue
	def self.enqueue(process, op = 'wait', channel = 'ing', tid = -1, is_replication = false)
		pid = process.id
		Xenodot::Backend.sql('insert into pivm.vm_queue (process_id, operation, channel, thread_id, is_replication) values ($1, $2, $3, $4, $5 )', [ pid, op, channel.to_s, tid, is_replication ],[ :int4, :text, :text, :int4, :bool ])
	end
	
	# Dequeue the next process from the queue that mathes the parameters. 
	# returns a PiVM::Process or nil
	def self.dequeue(operation = 'wait', channel = 'ing', include_replications = true)
		res = Xenodot::Backend.sql('select * from pivm.vm_dequeue( $1, $2, $3)',[operation, channel.to_s, include_replications], [:text, :text, :bool], :count => 1)
		if res and res[0]
			process = Xenodot::Node[res[0]]
			process.act_as PiVM::Process
			process
		else
			nil
		end
	end
 end
end