module Xenodot
  module Backend
    
    # This is voodoo
    # Input is the parent_hierarchy (can be null) and a position > 0
    # Position is encoded as follows:
    # if < 10 return parent_hierarchy + 1..9
    # if < 36 return parent_hierarchy + 'A'..'Z'
    # if < 62 return parent_hierarchy + 'a'..'z'
    # else return parent_hierarchy + '~' + hierarchy(position-61)
    #
    # This allows for string operations on a tree (order by hierarchy will result in correct tree order)
    def self.Hierarchy(parent_hierarchy, position)
      return '' unless parent_hierarchy
      raise 'Illegal position, must be > 1' if position.nil? or position < 1
      child_hierarchy = parent_hierarchy.clone

      while position > 0
        case
        when position > 61:
          child_hierarchy << '~'
          position -= 61;
        when position < 10:
          return child_hierarchy << (48 + position).chr
        when position < 36:
          return child_hierarchy << (55 + position).chr
        else
          return child_hierarchy << (61 + position).chr
        end
      end
      return child_hierarchy
    end
  end
end