module Xenodot
  module Backend
    def self.subtransaction!
      savepoint = "savepoint xenodot_#{Time.now.to_i}"
      begin
        sql(savepoint, [], [])
        break_called = true
        yield
        break_called = false
        sql("release #{savepoint}", [], [])
      rescue => ex
        raise ex
      ensure
        sql("rollback to #{savepoint}", [], []) if ex or break_called
      end
    end
  end
end