module Xenodot
  module Server
    class MongrelHandler < Mongrel::HttpHandler
      def process(request, response)
        p request
        p Mongrel::HttpRequest.query_parse(request.params['QUERY_STRING'])
        protocol = "http://" if request.params['SERVER_PROTOCOL'] == "HTTP/1.1"
        uri = URI.parse(protocol + request.params['HTTP_HOST'] + request.params['REQUEST_PATH'])
        request.params['REQUEST_URI'] = uri.to_s

        puts "Request to #{uri}"

        case request.params['REQUEST_METHOD']
        when 'GET':
          if URI.exist?(uri)
            response.start(200) do |head, out|
              root = Node[uri]
              out.write root.to_xml
              head['Content-Type'] = root[:content_type] || 'text/xml'
            end
          else
            response.start(404) do |head, out|
              out.write "Not found"
            end
          end
        when 'POST':
          template = request.params['HTTP_URI_TEMPLATE']
          absoluter = template.gsub(/\{uniq\}/, ';xenodot;')
          template = (uri + absoluter).to_s.gsub(/;xenodot;/, '{uniq}')
          
          if (request.body.size == 0) and (generated = URI.generate_from(template))
            response.start(201) do |head,out|
              #head["Content-Type"] = "text/plain"
              head['Location'] = generated
              puts "Generated URI #{generated}"
            end
          end
        when 'PUT':
          URI.PUT(request, response)
        else
        end
      end
    end
  end
end