require 'tmpdir'
require 'pathname'

class String
	def find_line(s)
		self.each_with_index{|line,i|
			return i+1 if line.index(s)
		}
		return nil
	end
end

filenames = ['dom/dom_spec.rb'] #,'dom/xpath_spec.rb']

filenames.each do |filename|

	file = File.join(File.dirname(__FILE__),'..',filename)
	orig_content = File.read(file)
	content = orig_content.clone
	content.gsub!(/reset_xenodot_database/,"")
	content.gsub!(/(before.*?\bdo\s*?)\n(.*?)\bend\b/m,
		%q{	\1
		reset_xenodot_database
		@filename = (Pathname.new(Dir.tmpdir) + "spec.txt").to_s
		Xenodot::Backend.sql(%q\{create or replace function xenodot.spec_setup( 	filename text) returns void as $ruby$
				init_xenodot
				\2
				
				require 'rubygems'
				require 'spec'
	
				@out = File.new(filename, 'w+')
				@out.chmod(0666)
		
				$stderr.reopen(@out)
				$stdout.reopen(@out)
				
		$ruby$ language plruby;\},[],[])
		Xenodot::Backend.sql('select xenodot.spec_setup($1)',[@filename],[:text])
	end
	
	after(:each) do
		Xenodot::Backend.sql("create or replace function xenodot.spec_teardown() returns void as $ruby$
		@out.close
		$ruby$ language plruby;",[],[])
		Xenodot::Backend.sql("select xenodot.spec_teardown()",[],[]);
		$stdout.write(File.read(@filename))
		$stdout.write("\n")
	end}
	)
	
	content.gsub!(/(^\s*it.*?\bdo\s*\n)(.*?)\bend\b/m){ |s|
		line = orig_content.find_line($1.strip)
	
		 $1 +
		%q{	Xenodot::Backend.sql(%q\{create or replace function xenodot.spec_test(file text) returns void as $ruby$
				begin
				} + "__myline__ = #{line} - __LINE__ \n" +
				$2 +
		%q{	rescue
				t = $@[-1].split(/:/,3)
				$@[-1] = file + ':' + (t[1].to_i(10) + __myline__).to_s
				raise $!.message << "\n\tfrom " << $@.join("\n\tfrom ")
			end
			$ruby$ language plruby;\},[],[])
			Xenodot::Backend.sql("select xenodot.spec_test($1)",[filename],[:text]);
		end}
	}
	
	

	eval content
# 	content.each_with_index do |line,i|
# 		$stdout.write ("#{i+1} #{line}")
# 	end
end
