#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

module PiVM
 class Queue
 
	# enque a process into the waiting queue
	def self.enqueue(process, op = 'wait', channel = 'ing', tid = -1, is_replication = false)
 		raise "Abstract method, has to be implemented"
	end
	
	# Dequeue the next process from the queue that mathes the parameters. 
	# returns a PiVM::Process or nil
	def self.dequeue(operation = 'wait', channel = 'ing', include_replications = true)
 		raise "Abstract method, has to be implemented"
	end
 end
end