#
# Copyright (C) 2008  Olaf Märker
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

require 'mongrel'
$DEBUG = true

module PiVM::Server

 class SimpleHandler < Mongrel::HttpHandler
    def process(request, response)
    	Xenodot::Backend::Database.connection
		query_props = Mongrel::HttpRequest.query_parse(request.params["QUERY_STRING"])
		verb = request.params["REQUEST_METHOD"]
		#uri = URI.parse(request.params["SERVER_NAME"].to_s+ request.params["REQUEST_PATH"].to_s)
		uri = URI.parse(request.params["REQUEST_PATH"].to_s)
    	p "got #{verb} on #{uri}" if $DEBUG
    	body = Mongrel::HttpRequest.query_parse(request.body.read)
    	p "body is #{body.inspect}" if $DEBUG
		p "Header is #{request.params.inspect}"
		req = PiVM.convert_hash(request.params)
		props = PiVM.convert_hash(query_props)
		body = PiVM.convert_hash(body)
		# v o
		output_channel = PiVM.fresh_name("o")
		
		# i<output_channel, verb, request>
		process = PiVM::Queue.dequeue('read',uri)
		if process
			p process.current_activity.to_s if $DEBUG
			# do communicate
			if process.current_activity.type == 'replication'
				process = PiVM::Pi.replication2(process)
			end
			PiVM::Pi.read(process, output_channel, req, props, body)
			PiVM::Queue.enqueue(process)
		else
			# TODO create process node with i<output_channel, verb, request>
			warn "not yet implemented"
			
			# enque process
		end
		
		process = nil
		
		# o(code, response)
		until process
			sleep(1)
			process = PiVM::Queue.dequeue('write',output_channel)
		end		
		code, resp = PiVM::Pi.write(process)
		
		

      response.start(code) do |head,out|
        head["Content-Type"] = "text/html"
        out.write(resp)
      end
    end
 end

 # TODO: Nicht die gesamte Datenbank darf bei einem Neustart gelöscht werden
 reset_pivm_database
 h = Mongrel::HttpServer.new("0.0.0.0", "3000")
 h.register("/vm", SimpleHandler.new)
 h.register("/files", Mongrel::DirHandler.new("."))
 # Load processes
 PiVM.load(File.join(File.dirname(__FILE__),'../test/server_data.pi'))
 
 # Start the processes
 uri = '/vm/broker'
 broker = PiVM.create_process(PiVM.agent('Broker').start)
 broker.substitute!('uri',uri)
 # TODO: handle process as often as needed, for example if 
 PiVM::Queue.enqueue(broker)
 #PiVM.handle_process(broker)
 
 
 # Start the workers
 4.times do
 	PiVM::Worker.new
 end
 h.run.join
end