describe PiVM::Queue do

	before(:each) do 
		reset_pivm_database
		PiVM.init
		PiVM.load(File.join(File.dirname(__FILE__),"pi_spec.xml"))
	end

	it "should store processes thats wait for processing" do
		agent = PiVM.agent(:P)
		p1 = PiVM.create_process(agent.start)
		PiVM::Queue.enqueue(p1)
		p2 = PiVM::Queue.dequeue
		p2.should == p1
		p2.kind_of? Process
	end
	
	it "should store processes that wait for communication" do
		agent = PiVM.agent(:S)
		p1 = PiVM.create_process(agent.start)
		PiVM::Queue.enqueue(p1, 'read', 'a')
		PiVM::Queue.dequeue.should be_nil
		PiVM::Queue.dequeue('read', 'b').should be_nil
		PiVM::Queue.dequeue('write', 'a').should be_nil
		p2 = PiVM::Queue.dequeue('read', 'a')
		p2.should == p1
		p2.kind_of? Process
	end
	
	it "should be usable by many processes in parallel" do
	end
	
end